<template>
<div class="tag-choser">
    <div class="title">
        选择几个最能描述你的标签
    </div>
    <div class="tag-container">
        <div 
            v-for="(tag,i) in allTags"
            :key="i"
        >
        <div class="tag" v-if="setTagClass(tag)==true" @click="changeState(tag,i)"> {{tag.name}} </div>
        <div class="tag-chosen" v-if="setTagClass(tag)==false" @click="changeState(tag,i)">{{tag.name}}</div>
        </div>
    </div>
</div>
</template>

<script>
import axios from 'axios'
export default {
  name: "TagChoser",
  data() {
    return {
        chosenTags:this.chosenTagsProps,
        allTags:[],
        tagVisible:true
    };
  },
  props:[
      'chosenTagsProps',
  ],
  mounted: async function(){
    this.$api.getTags().then((res)=>{
        this.allTags=res.data.data;
        console.log(this.chosenTags)
    })
  },
  methods: {
      setTagClass: function(tag){
          let flag=false;
          for(let item in this.chosenTags){
            if(tag['id']==this.chosenTags[item]['id']){
              return false;
              flag=true;
            } 
          }
          if(flag==false){
              return true;
          }
      },
      changeState: function(tag, i){
          let flag=false;
            //TODO
            //1/chosenTag数组的更新
            //2/API更新my tag
            //3/界面颜色更新
          for(let item in this.chosenTags){
                
                console.log(this.chosenTags[item]);
                if(tag['id']==this.chosenTags[item]['id']){
                    flag=true;
                    //console.log(this.chosenTags[item]['id'])
                    this.$api.deleteMyTagById(parseInt(this.chosenTags[item]['id'])).then((res)=>{
                        console.log(res)
                    }).catch((res)=>{
                        console.log(res)
                    })
                    this.chosenTags.splice(item,1);
                    console.log(this.chosenTags)
                    
                }
              }
          if(flag==false){
              this.chosenTags.push(tag);
              this.$api.addMyTagById(tag['id'])
              console.log(this.chosenTags)
          }
      }
  },
  destroyed() {
  }
};
</script>

<style lang="less" scoped>
.tag-choser{
    height: 100%;
    width: 100%;
    padding: 20px 20px 0 20px;
    box-sizing: border-box;
    .title{
        font-size: 14px;
        font-weight: 500;
        color: #777;
        margin-bottom: 24px;
        text-align: center;
    }
}
.tag-container{
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    align-content: flex-start;
    justify-content: center;
    .tag{
        display: inline-block;
        color: #666464;
        width:auto;
        font-size: 14px;
        font-weight: bold;
        letter-spacing: .05em;
        display: inline-block;
        height: 32px;
        line-height: 32px;
        padding: 0 12px 0 12px;
        border: 1.5px #3170ff solid;
        border-radius: 8px;
        margin-right: 11px;
        margin-bottom: 10px;
    }
    .tag-chosen{
        color: #ffffff;
        background: #3170ff;
        width:auto;
        font-size: 14px;
        font-weight: bold;
        letter-spacing: .05em;
        display: inline-block;
        height: 32px;
        line-height: 32px;
        padding: 0 12px 0 12px;
        border: 1.5px #3170ff solid;
        border-radius: 8px;
        margin-right: 11px;
        margin-bottom: 10px;
    }
}
</style>
